"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withHTML = void 0;

var _addons = require("@storybook/addons");

var _shared = require("./shared");

var withHTML = (0, _addons.makeDecorator)({
  name: 'withHTML',
  parameterName: 'html',
  skipIfNoParametersOrOptions: false,
  wrapper: function wrapper(getStory, context, _ref) {
    var _ref$options = _ref.options,
        options = _ref$options === void 0 ? {} : _ref$options;

    var channel = _addons.addons.getChannel();

    var htmlMarkup = getStory(context);
    channel.emit(_shared.EVENT_CODE_RECEIVED, {
      html: htmlMarkup,
      options: options
    });
    return htmlMarkup;
  }
});
exports.withHTML = withHTML;